tests: skip tests by hostname
[nit.git] / tests / tests.sh
1 #!/bin/bash
2 # This file is part of NIT ( http://www.nitlanguage.org ).
3 #
4 # Copyright 2004-2008 Jean Privat <jean@pryen.org>
5 #
6 # Licensed under the Apache License, Version 2.0 (the "License");
7 # you may not use this file except in compliance with the License.
8 # You may obtain a copy of the License at
9 #
10 # http://www.apache.org/licenses/LICENSE-2.0
11 #
12 # Unless required by applicable law or agreed to in writing, software
13 # distributed under the License is distributed on an "AS IS" BASIS,
14 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
15 # See the License for the specific language governing permissions and
16 # limitations under the License.
17
18 # This shell script compile, run and verify Nit program files
19
20 # Set lang do default to avoid failed tests because of locale
21 export LANG=C
22 export LC_ALL=C
23 export NIT_TESTING=true
24 export NIT_SRAND=0
25
26 unset NIT_DIR
27
28 # Get the first Java lib available
29 shopt -s nullglob
30 JAVA_HOME=$(dirname $(dirname $(readlink -f $(which javac))))
31
32 paths=`echo $JAVA_HOME/jre/lib/*/{client,server}/libjvm.so`
33 paths=($paths)
34 JNI_LIB_PATH=`dirname ${paths[0]}`
35 shopt -u nullglob
36
37 outdir="out"
38 compdir="nit_compile"
39
40 # User CPU time limit (in seconds)
41 # Is used to avoid to CPU intensive test (infinite loops). See ulimit -t
42 usertimelimit=600 # 1 CPU minute
43
44 # Real-time limit (in seconds)
45 # Is used to avoid waiting or sleeping tests.
46 # Require timeout or timelimit, or else is not used.
47 realtimelimit=300 # 5 min
48
49 # User limit for write files (in kilo-bytes)
50 # Is used to avoid execution that loop and fill the hard drive. See ulimit -f
51 # Note that a test might require a lot of temporary disk space (eg. nitc+gcc)
52 filelimit=100000 # ~100MB
53
54 # Limit (in bytes) for generated .res file.
55 # Larger ones are truncated and will fail tests
56 # Is used to avoid processing huge crappy res file (diff, xml, etc)
57 reslimit=100000 # ~100KB
58
59 usage()
60 {
61 e=`basename "$0"`
62 cat<<END
63 Usage: $e [options] modulenames
64 -o option Pass option to the engine
65 -v Verbose (show tests steps)
66 -h This help
67 --engine Use a specific engine (default=nitc)
68 --noskip Do not skip a test even if the .skip file matches
69 --outdir Use a specific output folder (default=out/)
70 --compdir Use a specific temporary compilation folder (default=$compdir)
71 --node Run as a node in parallel, will not output context information
72 --autosav Copy the .res files directly in the sav folder overriding existing .res files
73 END
74 }
75
76 # Run a command with a timeout and a time count.
77 # Options:
78 # -o file write the user time into file (REQUIRED). see `-o` in `man time`
79 # -a append the time to the file (instead of overwriting it). see `-a` in `man time`
80 saferun()
81 {
82 local stop=false
83 local o=
84 local a=
85 while [ $stop = false ]; do
86 case "$1" in
87 -o) o="$2"; shift; shift;;
88 -a) a="-a"; shift;;
89 *) stop=true
90 esac
91 done
92 (
93 ulimit -f "$filelimit"
94 ulimit -t "$usertimelimit"
95 if test -d "$1"; then
96 find $1 | sort
97 elif test -n "$TIME"; then
98 $TIME -o "$o" $a $TIMEOUT "$@"
99 else
100 if test -n "$a"; then echo 0 >> "$o"; else echo 0 > "$o"; fi
101 $TIMEOUT "$@"
102 fi
103 )
104 }
105
106 # Output a timestamp attribute for XML, or an empty line
107 timestamp()
108 {
109 if test -n "$TIMESTAMP"; then
110 echo "timestamp='`$TIMESTAMP`'"
111 else
112 echo ""
113 fi
114
115 }
116
117 # Get platform specific commands ##########################
118
119 # Detect a working timeout
120 if sh -c "timelimit echo" 1>/dev/null 2>&1; then
121 TIMEOUT="timelimit -t $realtimelimit"
122 elif sh -c "timeout 1 echo" 1>/dev/null 2>&1; then
123 TIMEOUT="timeout ${realtimelimit}s"
124 else
125 echo "No timelimit or timeout command detected. Tests may hang :("
126 fi
127
128 # Detect a working time command
129 if env time --quiet -f%U true 2>/dev/null; then
130 TIME="env time --quiet -f%U"
131 elif env time -f%U true 2>/dev/null; then
132 TIME="env time -f%U"
133 else
134 TIME=
135 fi
136
137 # Detect a working date command
138 if date -Iseconds >/dev/null 2>&1; then
139 TIMESTAMP="date -Iseconds"
140 else
141 TIMESTAMP=
142 fi
143
144 # $1 is the pattern of the test
145 # $2 is the file to compare to
146 # the result is:
147 # 0: if the file to compare to do not exists
148 # 1: if the file match
149 # 2: if the file match with soso
150 # 3: if the file do not match
151 function compare_to_result()
152 {
153 local pattern="$1"
154 local sav="$2"
155 if [ ! -r "$sav" ]; then return 0; fi
156 test "`cat -- "$sav"`" = "UNDEFINED" && return 1
157 diff -u -- "$sav" "$outdir/$pattern.res" > "$outdir/$pattern.diff.sav.log"
158 if [ "$?" == 0 ]; then
159 return 1
160 fi
161 sed '/[Ww]arning/d;/[Ee]rror/d' "$outdir/$pattern.res" > "$outdir/$pattern.res2"
162 sed '/[Ww]arning/d;/[Ee]rror/d' "$sav" > "$outdir/$pattern.sav2"
163 grep '[Ee]rror' "$outdir/$pattern.res" >/dev/null && echo "Error" >> "$outdir/$pattern.res2"
164 grep '[Ee]rror' "$sav" >/dev/null && echo "Error" >> "$outdir/$pattern.sav2"
165 diff -u "$outdir/$pattern.sav2" "$outdir/$pattern.res2" > "$outdir/$pattern.diff.sav.log2"
166 if [ "$?" == 0 ]; then
167 return 2
168 else
169 return 3
170 fi
171 }
172
173 function xmlesc()
174 {
175 sed 's/&/\&amp;/g; s/</\&lt;/g; s/>/\&gt;/g; s/"/\&quot;/g; s/'"'"'/\&#39;/g'<<EOF
176 $*
177 EOF
178 }
179
180 # As argument: the pattern used for the file
181 function process_result()
182 {
183 # Result
184 pattern=$1
185 description=$2
186 pack=$3
187 SAV=""
188 NSAV=""
189 FIXME=""
190 NFIXME=""
191 SOSO=""
192 NSOSO=""
193 SOSOF=""
194 NSOSOF=""
195 OLD=""
196 LIST=""
197 FIRST=""
198
199 # Truncate too big res file
200 size=$(wc -c < "$outdir/$pattern.res")
201 if test -n "$reslimit" -a "$size" -gt "$reslimit"; then
202 # The most portable way to truncate a file is with Perl
203 perl -e "truncate \"$outdir/$pattern.res\", $reslimit;"
204 echo "***TRUNCATED***" >> "$outdir/$pattern.res"
205 fi
206
207 echo >>$xml "<testcase classname='`xmlesc "$pack"`' name='`xmlesc "$description"`' time='`cat -- "$outdir/$pattern.time.out"`' `timestamp`>"
208 #for sav in "sav/$engine/fixme/$pattern.res" "sav/$engine/$pattern.res" "sav/fixme/$pattern.res" "sav/$pattern.res" "sav/$pattern.sav"; do
209 for savdir in $savdirs; do
210 sav=$savdir/fixme/$pattern.res
211 compare_to_result "$pattern" "$sav"
212 case "$?" in
213 0)
214 ;; # no file
215 1)
216 OLD="$LIST"
217 FIXME="$sav"
218 LIST="$LIST $sav"
219 ;;
220 2)
221 if [ -z "$FIRST" ]; then
222 SOSOF="$sav"
223 FIRST="$sav"
224 fi
225 LIST="$LIST $sav"
226 ;;
227 3)
228 if [ -z "$FIRST" ]; then
229 NFIXME="$sav"
230 FIRST="$sav"
231 fi
232 LIST="$LIST $sav"
233 ;;
234 esac
235
236 sav=$savdir/$pattern.res
237 compare_to_result "$pattern" "$sav"
238 case "$?" in
239 0)
240 ;; # no file
241 1)
242 OLD="$LIST"
243 SAV="$sav"
244 LIST="$LIST $sav"
245 ;;
246 2)
247 if [ -z "$FIRST" ]; then
248 SOSO="$sav"
249 FIRST="$sav"
250 fi
251 LIST="$LIST $sav"
252 ;;
253 3)
254 if [ -z "$FIRST" ]; then
255 NSAV="$sav"
256 FIRST="$sav"
257 fi
258 LIST="$LIST $sav"
259 ;;
260 esac
261 done
262 OLD=`echo "$OLD" | sed -e 's/ */ /g' -e 's/^ //' -e 's/ $//'`
263 grep 'NOT YET IMPLEMENTED' "$outdir/$pattern.res" >/dev/null
264 NYI="$?"
265 if [ -n "$SAV" ]; then
266 if [ -n "$OLD" ]; then
267 echo "[*ok*] $outdir/$pattern.res $SAV - but $OLD remains!"
268 echo >>$xml "<error message='`xmlesc "ok $outdir/$pattern.res - but $OLD remains"`'/>"
269 remains="$remains $OLD"
270 test "$autosav" = "true" && rm "$OLD"
271 else
272 echo "[ok] $outdir/$pattern.res $SAV"
273 fi
274 ok="$ok $pattern"
275 elif [ -n "$FIXME" ]; then
276 if [ -n "$OLD" ]; then
277 echo "[*fixme*] $outdir/$pattern.res $FIXME - but $OLD remains!"
278 echo >>$xml "<error message='`xmlesc "ok $outdir/$pattern.res - but $OLD remains"`'/>"
279 remains="$remains $OLD"
280 test "$autosav" = "true" && rm "$OLD"
281 else
282 echo "[fixme] $outdir/$pattern.res $FIXME"
283 echo >>$xml "<skipped/>"
284 fi
285 todos="$todos $pattern"
286 elif [ "x$NYI" = "x0" ]; then
287 echo "[todo] $outdir/$pattern.res -> not yet implemented"
288 echo >>$xml "<skipped/>"
289 todos="$todos $pattern"
290 elif [ -n "$SOSO" ]; then
291 echo "[======= soso $outdir/$pattern.res $SOSO =======]"
292 echo >>$xml "<error message='`xmlesc "soso $outdir/$pattern.res $SOSO"`'/>"
293 echo >>$xml "<system-out><![CDATA["
294 cat -v -- "$outdir/$pattern.diff.sav.log" | head >>$xml -n 50
295 echo >>$xml "]]></system-out>"
296 nok="$nok $pattern"
297 echo "$ii" >> "$ERRLIST"
298 test "$autosav" = "true" && cp "$outdir/$pattern.res" "$SOSO"
299 elif [ -n "$SOSOF" ]; then
300 echo "[======= fixme soso $outdir/$pattern.res $SOSOF =======]"
301 echo >>$xml "<error message='`xmlesc "soso $outdir/$pattern.res $SOSO"`'/>"
302 echo >>$xml "<system-out><![CDATA["
303 cat -v -- "$outdir/$pattern.diff.sav.log" | head >>$xml -n 50
304 echo >>$xml "]]></system-out>"
305 nok="$nok $pattern"
306 echo "$ii" >> "$ERRLIST"
307 test "$autosav" = "true" && cp "$outdir/$pattern.res" && "$SOSO"
308 elif [ -n "$NSAV" ]; then
309 echo "[======= fail $outdir/$pattern.res $NSAV =======]"
310 echo >>$xml "<error message='`xmlesc "fail $outdir/$pattern.res $NSAV"`'/>"
311 echo >>$xml "<system-out><![CDATA["
312 cat -v -- "$outdir/$pattern.diff.sav.log" | head >>$xml -n 50
313 echo >>$xml "]]></system-out>"
314 nok="$nok $pattern"
315 echo "$ii" >> "$ERRLIST"
316 test "$autosav" = "true" && cp "$outdir/$pattern.res" "$NSAV"
317 elif [ -n "$NFIXME" ]; then
318 echo "[======= changed $outdir/$pattern.res $NFIXME ======]"
319 echo >>$xml "<error message='`xmlesc "changed $outdir/$pattern.res $NFIXME"`'/>"
320 echo >>$xml "<system-out><![CDATA["
321 cat -v -- "$outdir/$pattern.diff.sav.log" | head >>$xml -n 50
322 echo >>$xml "]]></system-out>"
323 nok="$nok $pattern"
324 echo "$ii" >> "$ERRLIST"
325 test "$autosav" = "true" && cp "$outdir/$pattern.res" "$NFIXME"
326 elif [ -s "$outdir/$pattern.res" ]; then
327 echo "[=== no sav ===] $outdir/$pattern.res is not empty"
328 echo >>$xml "<error message='no sav and not empty'/>"
329 echo >>$xml "<system-out><![CDATA["
330 cat -v >>$xml -- "$outdir/$pattern.res"
331 echo >>$xml "]]></system-out>"
332 nos="$nos $pattern"
333 echo "$ii" >> "$ERRLIST"
334 test "$autosav" = "true" && cp "$outdir/$pattern.res" "sav/"
335 else
336 # no sav but empty res
337 echo "[0k] $outdir/$pattern.res is empty"
338 ok="$ok $pattern"
339 fi
340 if test -s "$outdir/$pattern.cmp.err"; then
341 echo >>$xml "<system-err><![CDATA["
342 cat -v >>$xml -- "$outdir/$pattern.cmp.err"
343 echo >>$xml "]]></system-err>"
344 fi
345 echo >>$xml "</testcase>"
346 }
347
348 need_skip()
349 {
350 test "$noskip" = true && return 1
351 if echo "$1" | grep -f "$engine.skip" >/dev/null 2>&1; then
352 echo "=> $2: [skip]"
353 echo >>$xml "<testcase classname='`xmlesc "$3"`' name='`xmlesc "$2"`' `timestamp`><skipped/></testcase>"
354 return 0
355 fi
356 if test -n "$isinterpret" && echo "$1" | grep -f "exec.skip" >/dev/null 2>&1; then
357 echo "=> $2: [skip exec]"
358 echo >>$xml "<testcase classname='`xmlesc "$3"`' name='`xmlesc "$2"`' `timestamp`><skipped/></testcase>"
359 return 0
360 fi
361
362 # Skip by OS
363 os_skip_file=`uname`.skip
364 if test -e $os_skip_file && echo "$1" | grep -f "$os_skip_file" >/dev/null 2>&1; then
365 echo "=> $2: [skip os]"
366 echo >>$xml "<testcase classname='`xmlesc "$3"`' name='`xmlesc "$2"`' `timestamp`><skipped/></testcase>"
367 return 0
368 fi
369
370 # Skip by hostname
371 host_skip_file=`hostname -s`.skip
372 if test -e $host_skip_file && echo "$1" | grep -f "$host_skip_file" >/dev/null 2>&1; then
373 echo "=> $2: [skip hostname]"
374 echo >>$xml "<testcase classname='`xmlesc "$3"`' name='`xmlesc "$2"`' `timestamp`><skipped/></testcase>"
375 return 0
376 fi
377 return 1
378 }
379
380 skip_exec()
381 {
382 test "$noskip" = true && return 1
383 for savdir in $savdirs .; do
384 f="$savdir/exec.skip"
385 if echo "$1" | grep -f "$f" >/dev/null 2>&1; then
386 echo -n "_ no exec by $f; "
387 return 0
388 fi
389 done
390 return 1
391 }
392
393 skip_cc()
394 {
395 test "$noskip" = true && return 1
396 for savdir in $savdirs .; do
397 f="$savdir/cc.skip"
398 if echo "$1" | grep -f "$f" >/dev/null 2>&1; then
399 return 0
400 fi
401 done
402 return 1
403 }
404
405 find_nitc()
406 {
407 name="$enginebinname"
408 recent=`ls -t ../src/$name ../src/$name_[0-9] ../bin/$name ../c_src/$name 2>/dev/null | head -1`
409 if [[ "x$recent" == "x" ]]; then
410 echo "Could not find binary for engine $engine, aborting"
411 exit 1
412 fi
413 if [ "x$isnode" = "xfalse" ]; then
414 echo "Found binary for engine $engine: $recent $OPT"
415 fi
416 NITC=$recent
417 }
418
419 verbose=false
420 isnode=false
421 autosav=false
422 stop=false
423 engine=nitc
424 noskip=
425 savdirs=
426 while [ $stop = false ]; do
427 case $1 in
428 -o) OPT="$OPT $2"; shift; shift;;
429 -v) verbose=true; shift;;
430 -h) usage; exit;;
431 --engine) engine="$2"; shift; shift;;
432 --noskip) noskip=true; shift;;
433 --outdir) outdir="$2"; shift; shift;;
434 --compdir) compdir="$2"; shift; shift;;
435 --node) isnode=true; shift;;
436 --autosav) autosav=true; shift;;
437 *) stop=true
438 esac
439 done
440 enginebinname=$engine
441 isinterpret=
442 case $engine in
443 nitc|nitg)
444 engine=nitcs;
445 enginebinname=nitc;
446 OPT="--separate $OPT --compile-dir $compdir"
447 savdirs="sav/nitc-common/"
448 ;;
449 nitcs|nitg-s)
450 engine=nitcs;
451 enginebinname=nitc;
452 OPT="--separate $OPT --compile-dir $compdir"
453 savdirs="sav/nitc-common/"
454 ;;
455 nitce|nitg-e)
456 engine=nitce;
457 enginebinname=nitc;
458 OPT="--erasure $OPT --compile-dir $compdir"
459 savdirs="sav/nitc-common/"
460 ;;
461 nitcsg|nitg-sg)
462 engine=nitcsg;
463 enginebinname=nitc;
464 OPT="--semi-global $OPT --compile-dir $compdir"
465 savdirs="sav/nitc-common/"
466 ;;
467 nitcg|nitg-g)
468 engine=nitcg;
469 enginebinname=nitc;
470 OPT="--global $OPT --compile-dir $compdir"
471 savdirs="sav/nitc-common/"
472 ;;
473 nit)
474 engine=niti
475 isinterpret=true
476 ;;
477 niti)
478 enginebinname=nit
479 isinterpret=true
480 ;;
481 nitvm)
482 isinterpret=true
483 enginebinname=nit
484 OPT="--vm $OPT"
485 savdirs="sav/niti/"
486 ;;
487 emscripten)
488 enginebinname=nitc
489 OPT="-m emscripten_nodejs.nit --semi-global $OPT --compile-dir $compdir"
490 savdirs="sav/nitcsg/"
491 ;;
492 *)
493 echo "unknown engine $engine"
494 exit 1
495 ;;
496 esac
497
498 savdirs="sav/`hostname -s` sav/`uname` sav/$engine $savdirs sav/"
499
500 # The default nitc compiler
501 [ -z "$NITC" ] && find_nitc
502
503 # Set NIT_DIR if needed
504 [ -z "$NIT_DIR" ] && export NIT_DIR=..
505
506 # Mark to distinguish files among tests
507 # MARK=
508
509 if [ $# = 0 ]; then
510 usage;
511 exit
512 fi
513
514 # CLEAN the out directory
515 rm -rf "$outdir/" 2>/dev/null
516 mkdir "$outdir" 2>/dev/null
517
518 # File where error tests are outputed
519 # Old ERRLIST is backuped
520 ERRLIST=${ERRLIST:-errlist}
521 ERRLIST_TARGET=$ERRLIST
522
523 # Initiate new ERRLIST
524 if [ "x$ERRLIST" = "x" ]; then
525 ERRLIST=/dev/null
526 else
527 ERRLIST=$ERRLIST.tmp
528 > "$ERRLIST"
529 fi
530
531 ok=""
532 nok=""
533 todos=""
534
535 if [ "x$XMLDIR" = "x" ]; then
536 xml="tests-$engine.xml"
537 else
538 sum=`echo $@ | md5sum | cut -f1 -d " "`
539 xml="$XMLDIR/tests-$engine-$sum.xml"
540 mkdir -p "$XMLDIR"
541 fi
542
543 echo >$xml "<testsuites><testsuite>"
544
545 for ii in "$@"; do
546 if [ ! -f "$ii" ]; then
547 echo "File '$ii' does not exist."
548 continue
549 fi
550 f=`basename -- "$ii" .nit`
551
552 pack="tests.${engine}".`echo $ii | perl -p -e 's|^../([^/]*)/([a-zA-Z_]*).*|\1.\2| || s|^([a-zA-Z]*)[^_]*_([a-zA-Z]*).*|\1.\2| || s|\W*([a-zA-Z_]*).*|\1|'`
553
554 # Sould we skip the file for this engine?
555 need_skip "$f" "$f" "$pack" && continue
556
557 tmp=${ii/../AA}
558 if [ "x$tmp" = "x$ii" ]; then
559 includes="-I . -I ../lib/standard -I ../lib/standard/collection -I alt"
560 else
561 includes="-I alt"
562 fi
563
564 for i in "$ii" `./alterner.pl --start '#' --altsep '_' -- "$ii"`; do
565 bf=`basename -- "$i" .nit`
566 ff="$outdir/$bf"
567
568 # Sould we skip the alternative for this engine?
569 need_skip "$bf" "$bf" "$pack" && continue
570
571 echo -n "=> $bf: "
572
573 if [ -f "$f.inputs" ]; then
574 inputs="$f.inputs"
575 export MNIT_READ_INPUT="$f.inputs"
576 else
577 inputs=/dev/null
578 export MNIT_READ_INPUT=/dev/null
579 fi
580
581 ffout="$ff.bin"
582 if [ "$engine" = "emscripten" ]; then
583 ffout="$ff.bin.js"
584 fi
585
586 if [ -n "$isinterpret" ]; then
587 cat > "$ff.bin" <<END
588 exec $NITC --no-color $OPT $includes -- $(printf '%q' "$i") "\$@"
589 END
590 chmod +x "$ff.bin"
591 > "$ff.cmp.err"
592 > "$ff.compile.log"
593 ERR=0
594 echo 0.0 > "$ff.time.out"
595 else
596 if skip_cc "$bf"; then
597 nocc="--no-cc"
598 else
599 nocc=
600 fi
601 # Compile
602 if [ "x$verbose" = "xtrue" ]; then
603 echo ""
604 echo $NITC --no-color $OPT -o "$ffout" "$includes" $nocc "$i"
605 fi
606 NIT_NO_STACK=1 JNI_LIB_PATH=$JNI_LIB_PATH JAVA_HOME=$JAVA_HOME \
607 saferun -o "$ff.time.out" $NITC --no-color $OPT -o "$ffout" $includes $nocc "$i" 2> "$ff.cmp.err" > "$ff.compile.log"
608 ERR=$?
609 if [ "x$verbose" = "xtrue" ]; then
610 cat -- "$ff.compile.log"
611 cat >&2 -- "$ff.cmp.err"
612 fi
613 # Clean
614 rm -r "$compdir" 2>/dev/null
615 fi
616 if [ "$engine" = "emscripten" ]; then
617 echo > "$ff.bin" "nodejs $ffout \"\$@\""
618 chmod +x "$ff.bin"
619 if grep "Fatal Error: more than one primitive class" "$ff.compile.log" > /dev/null; then
620 echo " [skip] do no not imports kernel"
621 echo >>$xml "<testcase classname='`xmlesc "$pack"`' name='`xmlesc "$bf"`' `timestamp`><skipped/></testcase>"
622 continue
623 fi
624 fi
625 if [ "$ERR" != 0 ]; then
626 echo -n "! "
627 cat -- "$ff.compile.log" "$ff.cmp.err" > "$ff.res"
628 process_result "$bf" "$bf" "$pack"
629 elif [ -n "$nocc" ]; then
630 # not compiled
631 echo -n "nocc "
632 > "$ff.res"
633 process_result "$bf" "$bf" "$pack"
634 elif [ -x "$ff.bin" ]; then
635 if skip_exec "$bf"; then
636 # No exec
637 > "$ff.res"
638 process_result "$bf" "$bf" "$pack"
639 break
640 fi
641 echo -n ". "
642 # Execute
643 args=""
644 if [ "x$verbose" = "xtrue" ]; then
645 echo ""
646 echo "NIT_NO_STACK=1 $ff.bin" $args
647 fi
648 NIT_NO_STACK=1 LD_LIBRARY_PATH=$JNI_LIB_PATH \
649 saferun -a -o "$ff.time.out" "$ff.bin" $args < "$inputs" > "$ff.res" 2>"$ff.err"
650 mv "$ff.time.out" "$ff.times.out"
651 awk '{ SUM += $1} END { print SUM }' "$ff.times.out" > "$ff.time.out"
652
653 if [ "x$verbose" = "xtrue" ]; then
654 cat -- "$ff.res"
655 cat >&2 -- "$ff.err"
656 fi
657 if [ -f "$ff.write" ]; then
658 cat -- "$ff.write" >> "$ff.res"
659 elif [ -d "$ff.write" ]; then
660 LANG=C /bin/ls -F "$ff.write" >> "$ff.res"
661 fi
662 cp -- "$ff.res" "$ff.res2"
663 cat -- "$ff.cmp.err" "$ff.err" "$ff.res2" > "$ff.res"
664 process_result "$bf" "$bf" "$pack"
665
666 if [ -f "$f.args" ]; then
667 fargs=$f.args
668 cptr=0
669 while read line; do
670 ((cptr=cptr+1))
671 args="$line"
672 bff=$bf"_args"$cptr
673 fff=$ff"_args"$cptr
674 name="$bf args $cptr"
675
676 # Sould we skip the input for this engine?
677 need_skip "$bff" " $name" "$pack" && continue
678
679 # use a specific inputs file, if required
680 if [ -f "$bff.inputs" ]; then
681 ffinputs="$bff.inputs"
682 else
683 ffinputs="$inputs"
684 fi
685
686 rm -rf "$fff.res" "$fff.err" "$fff.write" 2> /dev/null
687 if [ "x$verbose" = "xtrue" ]; then
688 echo ""
689 echo "NIT_NO_STACK=1 $ff.bin" $args
690 fi
691 echo -n "==> $name "
692 echo "$ff.bin $args" > "$fff.bin"
693 chmod +x "$fff.bin"
694 WRITE="$fff.write" saferun -o "$fff.time.out" sh -c "NIT_NO_STACK=1 $fff.bin < $ffinputs > $fff.res 2>$fff.err"
695 if [ "x$verbose" = "xtrue" ]; then
696 cat -- "$fff.res"
697 cat >&2 -- "$fff.err"
698 fi
699 if [ -f "$fff.write" ]; then
700 cat -- "$fff.write" >> "$fff.res"
701 elif [ -d "$fff.write" ]; then
702 LANG=C /bin/ls -F -- "$fff.write" >> "$fff.res"
703 fi
704 if [ -s "$fff.err" ]; then
705 cp -- "$fff.res" "$fff.res2"
706 cat -- "$fff.err" "$fff.res2" > "$fff.res"
707 fi
708 process_result "$bff" " $name" "$pack"
709 done < "$fargs"
710 fi
711 elif [ -f "$ff.bin" ]; then
712 #Not executable (platform?)"
713 > "$ff.res"
714 process_result "$bf" "$bf" "$pack"
715 else
716 echo -n "! "
717 cat -- "$ff.cmp.err" > "$ff.res"
718 echo "Compilation error" > "$ff.res"
719 process_result "$bf" "$bf" "$pack"
720 fi
721 done
722 done
723
724 if [ "x$isnode" = "xfalse" ]; then
725 echo "engine: $engine ($enginebinname $OPT)"
726 echo "ok: " `echo $ok | wc -w` "/" `echo $ok $nok $nos $todos | wc -w`
727
728 if [ -n "$nok" ]; then
729 echo "fail: $nok"
730 echo "There were $(echo $nok | wc -w) errors ! (see file $ERRLIST)"
731 fi
732 if [ -n "$nos" ]; then
733 echo "no sav: $nos"
734 fi
735 if [ -n "$todos" ]; then
736 echo "todo/fixme: $todos"
737 fi
738 if [ -n "$remains" ]; then
739 echo "sav that remains: $remains"
740 fi
741 fi
742
743 # write $ERRLIST
744 if [ "x$ERRLIST" != "x" ]; then
745 if [ -f "$ERRLIST_TARGET" ]; then
746 mv "$ERRLIST_TARGET" "${ERRLIST_TARGET}.bak"
747 fi
748 uniq $ERRLIST > $ERRLIST_TARGET
749 rm $ERRLIST
750 fi
751
752 echo >>$xml "</testsuite></testsuites>"
753
754 if [ -n "$nok" ]; then
755 exit 1
756 else
757 exit 0
758 fi